// THEXDER (PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];
unsigned char dir[0x100*0x0c];
unsigned char fat[0x100];

#define	cv_trk(x)	x>>1
#define	cv_C(x)		x>>2
#define	cv_H(x)		(x>>1)&1
#define	cv_R(x)		((x&1)<<3)+1
#define	cv_bcd(x)	((x&0xf0)>>4)*10+(x&0x0f)	// BCDoCgϊ

D88 disk;
FILE *fp;

int main(int argc, char *argv[])
{
	char fname[11];
	int i,fn;
	int fd,ld;
	unsigned int yy,mm,dd,hh,mn;
	unsigned char *lp;
	int size;

	if (argc != 2) {
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++) {
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		// fBNgFAT̓ǂݍ
		disk.ReadDATA(0x25, 0x12, 0x01, 0x01, 0x01, dir, sizeof(dir));
		disk.ReadDATA(0x25, 0x12, 0x01, 0x0e, 0x01, fat, sizeof(fat));
		for (fn=0; fn<(sizeof(dir)/0x10); fn++)
		{
			unsigned char *ent = &dir[fn*0x10];
			if (*ent == 0xff) break;	// fBNg̍Ō
			if (*ent == 0x00) continue;	// 폜t@C
			int i;
			int fnp = 0;
			for (i=0x00; i<0x09; i++)
			{
				char c = ent[i];		// t@CPo
				fname[fnp++] = c;		// t@C\
			}
			fname[fnp++] = '\0';		// ̍Ō

			fd = *(ent+0x0a);			// 擪NX^
			yy = cv_bcd(*(ent+0x0f));	// t(N) (BCD)
			mm = cv_bcd(*(ent+0x0e));	// t() (BCD)
			dd = cv_bcd(*(ent+0x0d));	// t() (BCD)
			hh = cv_bcd(*(ent+0x0c));	// t() (BCD)
			mn = cv_bcd(*(ent+0x0b));	// t() (BCD)
			lp = buff;

//			printf("%-5s %04x : %02x ",fname,size,fd);
//			printf("%-9s %02d/%02d/%02d %02d:%02d | ",fname,yy,mm,dd,hh,mn);

			while (fat[fd] < 0xc0) {
//				printf ("%02x ",fd);
				disk.ReadDATA(cv_trk(fd), cv_C(fd), cv_H(fd), cv_R(fd), 1, lp, 0x800);
				lp += 0x800;
				fd = fat[fd];			// FAT`FCH
				if (fd == 0xfe) fd++;
			}

			// FAT̍Ō
//			printf("%02x\n",fat[fd]);
			ld = fat[fd] & 0x0f;
			disk.ReadDATA(cv_trk(fd), cv_C(fd), cv_H(fd), cv_R(fd), 1, lp, ld*0x100);
			size = (lp-buff)+ld*0x100;

			// o
			fp = fopen(fname,"wb");
//			printf("cutting ... %-9s  size = %5d\n",fname,size);
			printf("%-9s %04x %02d/%02d/%02d %02d:%02d\n",fname,size,yy,mm,dd,hh,mn);
			if (size != fwrite(buff, 1, size, fp))
			{
				fprintf(stderr, "t@Cɏ߂܂̂Œf܂.\n");
				exit(1);
			}
			fclose(fp);
		}
		return 0;
	}
}

